#include "my_spawn.h"

#include <cstdlib>
#include <sys/stat.h>
#include <sys/wait.h>
#include <unistd.h>


void my_spawn(char* args[]) {

    pid_t pid_1 = ::fork();

    // parent
    if (pid_1 < 0) {
        // TODO: handle fork error
        return;
    }
    if (pid_1 > 0) {
        int status;
        ::waitpid(pid_1, &status, 0);
        // TODO: manage errors coming from child and grandchild
        return;
    }

    // child
    if (::setsid() < 0) {
        // TODO: handle setsid() error
        exit(EXIT_FAILURE);
    }
    ::signal(SIGCHLD, SIG_IGN);
    ::signal(SIGHUP, SIG_IGN);

    pid_t pid_2 = ::fork();
    if (pid_2 < 0) {
        // TODO: handle fork error
        exit(EXIT_FAILURE);
    }
    if (pid_2 > 0) {
        exit(EXIT_SUCCESS);
    }

    // grandchild
    if (::execve(args[0], args, ::environ) < 0) {
        // TODO: manage execve error
        exit(EXIT_FAILURE);
    }
}
